#include "ADSRapi.h"


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

INT ADSReadPort(DWORD cbInput, 
			    BYTE *pInput, 
			    DWORD *pcbOutput, 
			    BYTE **ppOutput, 
			    PVOID reserved)
{
	TCHAR			*szPort = new TCHAR[6];
	HANDLE			hPort	= INVALID_HANDLE_VALUE;
	DWORD			dwRead	= 0;
	ReadPortType	*rpt;

	rpt = (ReadPortType*)pInput;

	BYTE			*buffer = new BYTE[rpt->bytes];

	// change input into unicode
	MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, rpt->szPortName, -1, szPort, 6);

	DEBUGMSG(TRUE, (_T("Reading port %s\r\n"), szPort));

	// open the port
	hPort = CreateFile(szPort, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, 0);

	if(hPort == INVALID_HANDLE_VALUE)
	{
		// open failed
		return -1;
	}
	
	// read the port
	if(!ReadFile(hPort, buffer, rpt->bytes, &dwRead, NULL))
	{
		return -2;
	}

	// sanity check
	if(rpt->bytes != dwRead)
	{
		return -3;
	}

	DEBUGMSG(TRUE, (_T("Read %i\r\n"), *buffer));

	// set the output value
	*pcbOutput = rpt->bytes;
	**ppOutput = *buffer;

	// close the port
	CloseHandle(hPort);

	//clean up
	delete szPort;

	return 0;
}

INT ADSWritePort(DWORD cbInput, 
				 BYTE *pInput, 
				 DWORD *pcbOutput, 
				 BYTE **ppOutput, 
				 PVOID reserved)
{
	TCHAR			*szPort		= new TCHAR[6];
	HANDLE			hPort		= INVALID_HANDLE_VALUE;
	DWORD			dwWritten	= 0;
	WritePortType	*wpt;

	wpt = (WritePortType*)pInput;

	BYTE			*buffer		= new BYTE[wpt->bytes];

	// change input into unicode
	MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, wpt->szPortName, -1, szPort, 6);

	DEBUGMSG(TRUE, (_T("Writing %i to %s\r\n"), wpt->data, szPort));

	// open the port
	hPort = CreateFile(szPort, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, 0);

	if(hPort == INVALID_HANDLE_VALUE)
	{
		// open failed
		return -1;
	}
	
	// write to the port
	if(!WriteFile(hPort, &wpt->data, wpt->bytes, &dwWritten, NULL))
	{
		return -2;
	}

	// sanity check
	if(wpt->bytes != dwWritten)
	{
		return -3;
	}

	// set the output value
	*pcbOutput = sizeof(BOOL);
	unsigned char b = (unsigned char)TRUE;
	*ppOutput = &b;

	// close the port
	CloseHandle(hPort);

	//clean up
	delete szPort;

	return 0;
}