// ADSRapi.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "rapi.h"
#include "stdio.h"

typedef struct
{
	char	szPortName[6];
	DWORD	bytes;

} ReadPortType;

typedef struct
{
	char	szPortName[6];
	BYTE	data;
	DWORD	bytes;

} WritePortType;

const wchar_t DllPath[] = L"\\windows\\ADSRAPI.dll";
const wchar_t ADS_WRITE_PORT[] = L"ADSWritePort";
const wchar_t ADS_READ_PORT[] = L"ADSReadPort";

int main(int argc, char* argv[])
{
	char c;
	int lret = 0;

	printf("starting...\r\n");

	if(CeRapiInit() != 0)
	{
		printf("RAPI failed to initialize.\r\n");
		scanf(&c);	
		return -1;
	}	

	// allocate input variable memory
	// RAPI memory management is non-intuitive
	// you must allocate the input variable with LocalAlloc and RAPI will release them
	// you must also call LocalFree on the output buffer though you never call LocalAlloc

	WritePortType *wpt = (WritePortType*)LocalAlloc(LPTR, sizeof(WritePortType));
	ReadPortType *rpt = (ReadPortType*)LocalAlloc(LPTR, sizeof(ReadPortType));
	DWORD dwOutput;
	BYTE  *output;

	printf("toggling LEDs\r\n");
	// test writing ports by toggling LEDs
	for(int i = 0 ; i < 5 ; i++)
	{
		strcpy(wpt->szPortName, "LED1:");
		wpt->bytes = 1;
		wpt->data = 1;

		CeRapiInvoke(DllPath, ADS_WRITE_PORT, sizeof(WritePortType), (unsigned char *)wpt, &dwOutput, &output, NULL, NULL);
		LocalFree(output);

		Sleep(10);

		strcpy(wpt->szPortName, "LED1:");
		wpt->bytes = 1;
		wpt->data = 0;

		CeRapiInvoke(DllPath, ADS_WRITE_PORT, sizeof(WritePortType), (unsigned char *)wpt, &dwOutput, &output, NULL, NULL);
		LocalFree(output);

		strcpy(wpt->szPortName, "LED2:");
		wpt->bytes = 1;
		wpt->data = 1;

		CeRapiInvoke(DllPath, ADS_WRITE_PORT, sizeof(WritePortType), (unsigned char *)wpt, &dwOutput, &output, NULL, NULL);
		LocalFree(output);

		Sleep(10);

		strcpy(wpt->szPortName, "LED2:");
		wpt->bytes = 1;
		wpt->data = 0;

		CeRapiInvoke(DllPath, ADS_WRITE_PORT, sizeof(WritePortType), (unsigned char *)wpt, &dwOutput, &output, NULL, NULL);
		LocalFree(output);

		strcpy(wpt->szPortName, "LED3:");
		wpt->bytes = 1;
		wpt->data = 1;

		CeRapiInvoke(DllPath, ADS_WRITE_PORT, sizeof(WritePortType), (unsigned char *)wpt, &dwOutput, &output, NULL, NULL);
		LocalFree(output);

		Sleep(10);

		strcpy(wpt->szPortName, "LED3:");
		wpt->bytes = 1;
		wpt->data = 0;

		CeRapiInvoke(DllPath, ADS_WRITE_PORT, sizeof(WritePortType), (unsigned char *)wpt, &dwOutput, &output, NULL, NULL);
		LocalFree(output);

		strcpy(wpt->szPortName, "LED2:");
		wpt->bytes = 1;
		wpt->data = 1;

		CeRapiInvoke(DllPath, ADS_WRITE_PORT, sizeof(WritePortType), (unsigned char *)wpt, &dwOutput, &output, NULL, NULL);
		LocalFree(output);

		Sleep(10);

		strcpy(wpt->szPortName, "LED2:");
		wpt->bytes = 1;
		wpt->data = 0;

		CeRapiInvoke(DllPath, ADS_WRITE_PORT, sizeof(WritePortType), (unsigned char *)wpt, &dwOutput, &output, NULL, NULL);
		LocalFree(output);
	}
	
	// read a digital input
	strcpy(rpt->szPortName, "IOA1:");
	rpt->bytes = 1;

	printf("reading IOA1: ");

	CeRapiInvoke(DllPath, ADS_READ_PORT, sizeof(ReadPortType), (unsigned char *)rpt, &dwOutput, &output, NULL, NULL);
	printf("%i\r\n", *output);	
	LocalFree(output);

	// read an analog input
	strcpy(rpt->szPortName, "AIN1:");
	rpt->bytes = 2;

	printf("reading AIN1: ");

	CeRapiInvoke(DllPath, ADS_READ_PORT, sizeof(ReadPortType), (unsigned char *)rpt, &dwOutput, &output, NULL, NULL);
	printf("%i\r\n", *output);	
	LocalFree(output);

	// exiting the app before calling CeRapiUninit will often cause fatal exceptions
	CeRapiUninit();

	printf("done.");

	scanf(&c);	

	return 0;
}
